import * as _nuxt_schema from '@nuxt/schema';

/** Nuxt Module Options */
interface PresetThemeOptions {
    /**
     * Import Anu Preset Theme with either CSS or SASS
     * You can either import CSS which doesn't require any additional setup
     * or SASS which requires you to install `sass` dependencies.
     *
     * @default 'css'
     */
    style?: 'css' | 'scss';
}
interface ModuleOptions {
    /**
     * Import Anu Preset Theme Default | Source npm pkg: `@anu-vue/preset-theme-default`
     * When enabled, it will automatically set up the default presets for Anu and Uno.
     * We recommend to enable this option to get the best experience.
     *
     * @default true
     */
    presetTheme?: PresetThemeOptions | boolean;
}
declare const _default: _nuxt_schema.NuxtModule<ModuleOptions>;

export { ModuleOptions, _default as default };
